import { TableSchema, SchemaDefinitions, IndexOptions, DynamicSchema as Schema } from "../DynamicSchema";
declare class DynamicSchema extends Schema {
    constructor();
    createTable(schemaInput: TableSchema): Promise<DynamicSchema>;
    dropTable(): Promise<DynamicSchema>;
    renameTable(newSlug: string, newName?: string): Promise<DynamicSchema>;
    addIndex(options: IndexOptions): Promise<DynamicSchema>;
    removeIndex(columnName: string): Promise<DynamicSchema>;
    read(tableSlug: string): Promise<DynamicSchema>;
    define(def: SchemaDefinitions): Promise<DynamicSchema>;
    renameColumn(name: string, newName: string): Promise<DynamicSchema>;
    _writeSchema(): Promise<DynamicSchema>;
}
export default function (connection: any): typeof DynamicSchema;
export {};
